<template>
  <div>
    <expanded-card :class="['project-card']">
      <template #title>
        Ключевые слова поисковик 'google.com'
      </template>

      <template #content>
        <prime-data-table
          scrollable
          :value="tableData['google.com']"
          :sort-field="googleSort.field"
          :sort-order="googleSort.order"
          @sort="setGoogleSort"
        >
          <prime-column
            v-for="col of columns"
            :key="col.field"
            :field="col.field"
            :header="col.header"
            :sortable="col.sortable"
            :frozen="col.frozen"
            :class="col.class"
          >
            <template #body="{ data }">
              {{ getData(data, col.field) }}
            </template>
          </prime-column>
        </prime-data-table>
      </template>
    </expanded-card>

    <expanded-card :class="['project-card']">
      <template #title>
        Ключевые слова поисковик 'yandex.ru'
      </template>

      <template #content>
        <prime-data-table
          scrollable
          :value="tableData['yandex.ru']"
          :sort-field="yandexSort.field"
          :sort-order="yandexSort.order"
          @sort="setYandexSort"
        >
          <prime-column
            v-for="col of columns"
            :key="col.field"
            :field="col.field"
            :header="col.header"
            :sortable="col.sortable"
            :frozen="col.frozen"
            :class="col.class"
          >
            <template #body="{ data }">
              <div :class="col.class">
                {{ getData(data, col.field) }}
              </div>
            </template>
          </prime-column>
        </prime-data-table>
      </template>
    </expanded-card>

    <expanded-card class="project-card">
      <template #title>
        Ключевые слова поисковик 'google.com'
      </template>
      <template #content>
        <prime-chart
          type="line"
          class="project-card_chart"
          :data="chartData['google.com']"
          :options="basicOptions"
        />
      </template>
    </expanded-card>

    <expanded-card class="project-card">
      <template #title>
        Ключевые слова поисковик 'yandex.ru'
      </template>
      <template #content>
        <prime-chart
          type="line"
          class="project-card_chart"
          :data="chartData['yandex.ru']"
          :options="basicOptions"
        />
      </template>
    </expanded-card>
  </div>
</template>

<script lang="ts">
import { extend } from 'lodash';
import PrimeChart from 'primevue/chart/Chart.vue';
import PrimeColumn from 'primevue/column/Column.vue';
import PrimeDataTable from 'primevue/datatable/DataTable.vue';
import { defineComponent, PropType } from 'vue';
import { KeywordExtended } from '@/models/keywords';
import { ProjectExtended } from '@/models/projects';
import { tops, searchEngines } from '@/models/results';
import ExpandedCard from './ExpandedCard.vue';
type TableData = (Record<number | string, string> & { keyword: string})

export const randomHexColor = (): string => {
  const MIN = 100;
  const MAX = 200;
  const randomInt = (min: number, max: number): number => Math.floor(min + Math.random() * (max + 1 - min));

  const rgb = Array(3)
    .fill(0)
    .map(() => {
      const value = randomInt(MIN, MAX).toString(16);
      return value.length < 2 ? `0${value}` : value;
    });

  return `#${rgb.join('')}`;
};

interface Sort {
  field: string;
  order: -1 | 1;
}

interface Data {
  yandexSort: Sort;
  googleSort: Sort;

  isGoogleExpand: boolean;
  isYandexExpand: boolean;
  colors: Record<string, string>;
}

export default defineComponent({
  name: 'project-info-by-keywords',
  components: {
    PrimeColumn,
    PrimeDataTable,
    PrimeChart,
    ExpandedCard,
  },
  props: {
    project: { type: Object as PropType<ProjectExtended>, required: true },
    keywords: { type: Array as PropType<KeywordExtended[]>, required: true },
    numberOfDaysInMonth: { type: Number, required: true },
  },
  data(): Data {
    return {
      yandexSort: {
        field: '',
        order: 1,
      },
      googleSort: {
        field: '',
        order: 1,
      },

      isGoogleExpand: false,
      isYandexExpand: false,
      colors: {},
    };
  },
  computed: {
    columns(): { field: string, header: string, sortable: boolean, frozen: boolean, class?: string }[] {
      const numberOfDays = this.numberOfDaysInMonth;
      const columns: { field: string, header: string, sortable: boolean, frozen: boolean, class?: string }[] = [{ field: 'keyword', header: 'Ключевое слово', sortable: true, frozen: true, class: 'project-keyword' }];
      tops.forEach((topItem) => {
        columns.push({
          field: `top${topItem}`,
          header: `Топ ${topItem}`,
          sortable: false,
          frozen: false,
          class: 'project-top',
        });
      });
      for (let i = 1; i <= numberOfDays; i++) {
        columns.push({ field: `${i}`, header: `${i}`, sortable: false, frozen: false, class: 'project-by-day' });
      }
      return columns;
    },
    tableData(): Record<typeof searchEngines[number], TableData[]> {
      const returnedData: Record<typeof searchEngines[number], TableData[]> = {
        'google.com': [],
        'yandex.ru': [],
      };
      for (const searchEngine of searchEngines) {
        if (this.project === null || this.keywords === null) {
          break;
        }
        const data: TableData[] = [];
        for (const keyword of this.project.keywords) {
          const item: TableData = { keyword: keyword.value };
          let topValues = tops.map(() => 0);
          const resultKeywords = this.keywords.find(extendedKeyword => extendedKeyword.id === keyword.id);
          if (resultKeywords !== undefined) {
            const results = resultKeywords.results.filter(result => result.searchEngine === searchEngine);

            for (const result of results) {
              topValues = topValues.map((topItem, index) => result.position !== null && result.position <= tops[index] ? topItem + 1 : topItem);
              const [, , day] = result.date.split(' ')[0].split('-');
              item[Number(day)] = result.position?.toString() || '-';
            }
          }
          tops.forEach((top, index) => {
            item[`top${top}`] = topValues[index].toString();
          });
          data.push(item);
        }

        returnedData[searchEngine] = data;
      }

      return returnedData;
    },
    chartData(): Record<typeof searchEngines[number], any> {
      const returnedData: Record<typeof searchEngines[number], any> = {
        'google.com': {},
        'yandex.ru': {},
      };

      for (const searchEngine of searchEngines) {
        const columnExceptFirst = this.columns.slice(1, this.columns.length);
        const labels: string[] = [];
        for (const column of columnExceptFirst) {
          if (column.field.includes('top')) {
            continue;
          }
          labels.push(column.header);
        }
        const datasets = [];

        for (const item of this.tableData[searchEngine]) {
          const color = this.colors[item.keyword];
          const data: unknown[] = [];
          for (const column of columnExceptFirst) {
            if (column.field.includes('top')) {
              continue;
            }
            data.push(this.getData(item, column.field));
          }
          datasets.push({
            label: item.keyword,
            data,
            fill: false,
            borderColor: color,
            backgroundColor: color,
            tension: .4,
          });
        }
        returnedData[searchEngine] = {
          labels,
          datasets,
        };
      }
      return returnedData;
    },
    basicOptions() {
      return {
        plugins: {
          legend: {
            labels: {
              color: '#495057',
            },
          },
        },
        interaction: {
          mode: 'index',
          intersect: false,
        },
        maintainAspectRatio: false,
        scales: {
          x: {
            ticks: {
              color: '#495057',
            },
            grid: {
              color: '#ebedef',
            },
          },
          y: {
            ticks: {
              precision: 0,
              color: '#495057',
            },
            grid: {
              color: '#ebedef',
            },
            reverse: true,
          },
        },
      };
    },
  },
  watch: {
    project: {
      handler() {
        for (const keyword of this.project.keywords) {
          if (!(keyword.value in this.colors)) {
            this.colors[keyword.value] = randomHexColor();
          }
        }
      },
      immediate: true,
    },
  },
  methods: {
    getData(data: Record<string, unknown>, field: string ) {
      if (field in data) {
        return data[field];
      }

      return '-';
    },
    setGoogleSort(event: any) {
      if (event.sortOrder === 1 && this.googleSort.field === event.sortField) {
        this.googleSort.field = '';
        this.googleSort.order = -1;
      } else {
        this.googleSort.field = event.sortField;
        this.googleSort.order = event.sortOrder;
      }
    },
    setYandexSort(event: any) {
      if (event.sortOrder === 1 && this.yandexSort.field === event.sortField) {
        this.yandexSort.field = '';
        this.yandexSort.order = -1;
      } else {
        this.yandexSort.field = event.sortField;
        this.yandexSort.order = event.sortOrder;
      }
    },
  },
});
</script>
